import 'package:flutter/foundation.dart';
import 'bloc_manager.dart';
import 'isolate_bloc_wrapper.dart';

import 'isolate_bloc.dart';
import 'isolate_bloc_connector.dart';

void register<Event, State>({@required IsolateBlocCreator create}) =>
    IsolateBlocConnector.instance.register<Event, State>(create);

IsolateBlocWrapper<State> createBloc<BlocT extends IsolateBloc<Object, State>, State>() {
  var blocManager = BlocManager.instance;
  assert(
      blocManager != null,
      "$BlocManager must not be null. "
      "Call `await $initialize()` and call this function");
  return blocManager.createBloc<BlocT, State>();
}

Future<void> initialize(Initializer userInitializer) async {
  return BlocManager.initialize(userInitializer);
}

// todo: create `getIsolatedBloc` function to be able to get IsolateBloc from another [IsolateBloc]
